Codeforces 604B - Alan Wake(二分)

B. More Cowbell
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
Kevin Sun wants to move his precious collection of n cowbells from Naperthrill to Exeter, where there is actually grass instead of corn. Before moving, he must pack his cowbells into k boxes of a fixed size. In order to keep his collection safe during transportation, he won’t place more than two cowbells into a single box. Since Kevin wishes to minimize expenses, he is curious about the smallest size box he can use to pack his entire collection.

Kevin is a meticulous cowbell collector and knows that the size of his i-th (1 ≤ i ≤ n) cowbell is an integer si. In fact, he keeps his cowbells sorted by size, so si - 1 ≤ si for any i > 1. Also an expert packer, Kevin can fit one or two cowbells into a box of size s if and only if the sum of their sizes does not exceed s. Given this information, help Kevin determine the smallest s for which it is possible to put all of his cowbells into k boxes of size s.

Input
The first line of the input contains two space-separated integers n and k (1 ≤ n ≤ 2·k ≤ 100 000), denoting the number of cowbells and the number of boxes, respectively.

The next line contains n space-separated integers s1, s2, …, sn (1 ≤ s1 ≤ s2 ≤ … ≤ sn ≤ 1 000 000), the sizes of Kevin’s cowbells. It is guaranteed that the sizes si are given in non-decreasing order.

Output
Print a single integer, the smallest s for which it is possible for Kevin to put all of his cowbells into k boxes of size s.

Examples
input
2 1
2 5
output
7
input
4 3
2 3 5 9
output
9
input
3 2
3 5 7
output
8
Note
In the first sample, Kevin must pack his two cowbells into the same box.

In the second sample, Kevin can pack together the following sets of cowbells: {2, 3}, {5} and {9}.

In the third sample, the optimal solution is {3, 5} and {7}.

題意:
給出n個數,要放到k個容器中,容器至多放兩個,問容器的最大體積.

解題思路:
二分最大體積,看能否裝下所有的數.
裝載的時候優先選擇最大的和最小的放到容器中.

AC代碼:

#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e5+5;
int a[maxn];
int n,k;
bool check(int x)
{
    for(int i = 1;i <= n;i++)   if(a[i] > x)    return 0;
    int head = 1;
    int tail = n;
    int cnt = 0;
    while(head <= tail)
    {
        if(a[head]+a[tail] <= x)    head++,tail--,cnt++;
        else                        tail--,cnt++;
    }
    if(cnt<= k) return 1;
    return 0;
}
int main()
{
    ios::sync_with_stdio(false);
    cin>>n>>k;
    for(int i = 1;i <= n;i++)   cin>>a[i];
    int l = 1;
    int r = 2e6+5;
    while(l <= r)
    {
        int mid = (l+r)>>1;
        if(check(mid))  r = mid-1;
        else            l = mid+1;
    }
    cout<<l;
    return 0;
}
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章